-- macro:
-- #showtooltip
-- /run ShamanMount:M(GetRunningMacro(),"ground_mount_name","flying_mount_name")
-- /click ShamanMount

ShamanMountData = {["MacroName"]=nil,["GroundMountName"]=nil,["FlyingMountName"]=nil}
local GhostWolfMacro = "/cast ghost wolf"
local WalterWalkingMacro = "/cast [@player]water walking\n"
local time=GetTime()

local f=CreateFrame("Button","ShamanMount",nil,"SecureActionButtonTemplate")

local MN,GMN,FMN

function f:M(MN,GMN,FMN)
  ShamanMountData["MacroName"]=GetMacroInfo(MN)
  ShamanMountData["GroundMountName"]=GMN
  ShamanMountData["FlyingMountName"]=FMN
  if not ShamanMountData["FlyingMountName"] then ShamanMountData["FlyingMountName"]=ShamanMountData["GroundMountName"] end
  if not InCombatLockdown() then
    self:SetAttribute("type","macro")
    if IsMounted() then
      self:SetAttribute("macrotext","/dismount [noflying]")
    elseif CanExitVehicle() then
      self:SetAttribute("macrotext","/run VehicleExit()")
    elseif strsub(GetMapInfo(),0,7)=="Vashjir" and GetTime()-time<1.0 and IsSwimming() and IsUsableSpell(ShamanMountData["FlyingMountName"]) and GetUnitSpeed("player")==0 then
      self:SetAttribute("macrotext",WalterWalkingMacro.."/cast "..ShamanMountData["FlyingMountName"])
    elseif strsub(GetMapInfo(),0,7)=="Vashjir" and IsUsableSpell("Abyssal Seahorse") and GetUnitSpeed("player")==0 then
      self:SetAttribute("macrotext",WalterWalkingMacro.."/cast Abyssal Seahorse")
    elseif IsUsableSpell(ShamanMountData["FlyingMountName"]) and IsSwimming() and GetUnitSpeed("player")==0 then
      self:SetAttribute("macrotext",WalterWalkingMacro.."/cast "..ShamanMountData["FlyingMountName"])
    elseif IsUsableSpell(ShamanMountData["FlyingMountName"]) and GetUnitSpeed("player")==0 then
      self:SetAttribute("macrotext","/cast "..ShamanMountData["FlyingMountName"])
    elseif IsUsableSpell(ShamanMountData["GroundMountName"]) and GetUnitSpeed("player")==0 then
      self:SetAttribute("macrotext",WalterWalkingMacro.."/cast "..ShamanMountData["GroundMountName"])
    else
      self:SetAttribute("macrotext",GhostWolfMacro)
    end
  end
end

f:SetScript("OnEvent",function(self,event)
  if event=="PLAYER_REGEN_DISABLED" then
    self:SetAttribute("type","macro")
    if UnitClass("player")=="Shaman" then
      self:SetAttribute("macrotext","/run if CanExitVehicle() then VehicleExit() end\n"..GhostWolfMacro)
    else
      self:SetAttribute("macrotext","/run if CanExitVehicle() then VehicleExit() end\n".."/dismount [noflying]")
    end
  end
  if event=="SPELL_UPDATE_USABLE" then
    if not IsUsableSpell("Abyssal Seahorse") then
      time = GetTime()
    end
  end
  if strsub(GetMapInfo()~=nil and GetMapInfo() or "",0,7)=="Vashjir" and IsSwimming() and (IsUsableSpell("Abyssal Seahorse") or UnitClass("player")~="Shaman" and GetSpellInfo("Abyssal Seahorse")) then
    SetMacroSpell(ShamanMountData["MacroName"],"Abyssal Seahorse")
  elseif IsUsableSpell(ShamanMountData["FlyingMountName"]) or UnitClass("player")~="Shaman" and IsFlyableArea() and GetSpellInfo(ShamanMountData["FlyingMountName"]) then
    SetMacroSpell(ShamanMountData["MacroName"],ShamanMountData["FlyingMountName"])
  elseif IsUsableSpell(ShamanMountData["GroundMountName"]) or UnitClass("player")~="Shaman" and GetSpellInfo(ShamanMountData["GroundMountName"]) then
    SetMacroSpell(ShamanMountData["MacroName"],ShamanMountData["GroundMountName"])
  elseif UnitClass("player")=="Shaman" then
    SetMacroSpell(ShamanMountData["MacroName"],"ghost wolf")
  end
end)

f:RegisterEvent("PLAYER_REGEN_DISABLED")
f:RegisterEvent("SPELL_UPDATE_USABLE")
f:RegisterEvent("ACTIONBAR_SLOT_CHANGED")
f:RegisterEvent("PLAYER_LOGIN")